/// <reference types="mapbox-gl" />
/// <reference types="node" />
import { EventEmitter } from 'events';
import { ThreeboxEventType, ThreeboxObject } from './Threebox';
export interface EventPayload {
    type: 'object' | 'feature';
    target?: ThreeboxObject | mapboxgl.MapboxGeoJSONFeature;
    [attachment: string]: any;
}
declare class EventDispatcher {
    emitter: EventEmitter;
    constructor();
    on(type: ThreeboxEventType, listener?: (payload?: EventPayload) => any): this;
    once(type: ThreeboxEventType, listener?: (payload?: EventPayload) => any): this;
    emit(type: ThreeboxEventType, payload?: EventPayload): this;
    off(type: ThreeboxEventType, listener?: (payload?: EventPayload) => any): this;
}
export default EventDispatcher;
