"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const events_1 = require("events");
class EventDispatcher {
    constructor() {
        this.emitter = new events_1.EventEmitter();
    }
    on(type, listener) {
        this.emitter.on.apply(this.emitter, [type, listener]);
        return this;
    }
    once(type, listener) {
        this.emitter.once.apply(this.emitter, [type, listener]);
        return this;
    }
    emit(type, payload) {
        this.emitter.emit.apply(this.emitter, [type, payload]);
        return this;
    }
    off(type, listener) {
        this.emitter.removeListener.apply(this.emitter, [type, listener]);
        return this;
    }
}
exports.default = EventDispatcher;
