"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MaterialDefaultOption = void 0;
const THREE = __importStar(require("three"));
const Utils_1 = __importDefault(require("./Utils"));
exports.MaterialDefaultOption = {
    material: 'MeshBasicMaterial',
    color: 'black',
    opacity: 1,
};
const Material = (option) => {
    let output;
    let _option;
    if (option) {
        _option = Utils_1.default.validate(option, exports.MaterialDefaultOption);
        if (_option.material && _option.material.isMaterial) {
            // check if user provided material object
            output = _option.material;
        }
        else if (_option.material || _option.color || _option.opacity) {
            // check if user provided any material parameters. create new material object based on that.
            const three = THREE;
            output = new three[_option.material]({ color: _option.color, transparent: _option.opacity < 1 });
        }
        else {
            // if neither, return default material
            output = generateDefaultMaterial();
        }
        output.opacity = _option.opacity;
    }
    else {
        // if no options, return default
        output = generateDefaultMaterial();
    }
    function generateDefaultMaterial() {
        const three = THREE;
        return three[exports.MaterialDefaultOption.material]({ color: exports.MaterialDefaultOption.color });
    }
    return output;
};
exports.default = Material;
