import mapboxgl from 'mapbox-gl';
import Threebox, { ThreeboxOption } from './Threebox';
export interface ThreeLayerOption {
    id?: string;
    visible?: boolean;
    threeboxOption?: ThreeboxOption;
}
declare class ThreeLayer implements mapboxgl.CustomLayerInterface {
    id: string;
    type: 'custom';
    renderingMode?: '3d';
    visible?: boolean;
    map: mapboxgl.Map;
    threebox: Threebox;
    threeboxOption: ThreeboxOption;
    constructor(option?: ThreeLayerOption);
    onRemove?(_map: mapboxgl.Map, _gl: WebGLRenderingContext): void;
    onAdd?(map: mapboxgl.Map, gl: WebGLRenderingContext): void;
    render(_gl: WebGLRenderingContext, _matrix: number[]): void;
}
export default ThreeLayer;
