"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Threebox_1 = __importDefault(require("./Threebox"));
class ThreeLayer {
    constructor(option) {
        this.id = option?.id || 'three-layer';
        this.type = 'custom';
        this.renderingMode = '3d';
        this.visible = option?.visible || true;
        this.threeboxOption = option?.threeboxOption || {};
    }
    onRemove(_map, _gl) {
        if (this.threebox) {
            this.threebox.dispose();
        }
    }
    onAdd(map, gl) {
        this.map = map;
        this.threebox = new Threebox_1.default(map, gl, this.threeboxOption);
    }
    render(_gl, _matrix) {
        this.threebox.update();
    }
}
exports.default = ThreeLayer;
