import mapboxgl from 'mapbox-gl';
import Threebox, { ThreeboxObject } from '../Threebox';
export declare type DragActionType = 'translate' | 'rotate';
declare class EventHandler {
    threebox: Threebox;
    map: mapboxgl.Map;
    canvas: HTMLElement;
    selectedObject: ThreeboxObject;
    draggedObject: ThreeboxObject;
    draggedAction: DragActionType;
    overedObject: ThreeboxObject;
    overedFeature: mapboxgl.MapboxGeoJSONFeature;
    selectedFeature: mapboxgl.MapboxGeoJSONFeature;
    start: mapboxgl.Point;
    rotationStep: number;
    gridStep: number;
    startCoords: number[];
    lngDiff: number;
    latDiff: number;
    constructor(threebox: Threebox, map: mapboxgl.Map);
    dispose: () => void;
    private attachEvent;
    private mousePos;
    private unselectFeature;
    private selectFeature;
    private unoverFeature;
    private unselectObject;
    private addTooltip;
    private removeTooltip;
    private handleClick;
    private handleMouseMove;
    private handleMouseOut;
    private handleMouseDown;
    private handleMouseUp;
}
export default EventHandler;
